package org.bdware.sc.udp;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
 import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

 
public class UDPMessage implements Serializable {
	private static final long serialVersionUID = -8103830946473687985L;
	int isPart = 0;
	public UDPMessageType type;
	public int id; // 要标记sender
	int order;
	int requestID;
	byte[] content;

	public UDPMessage() {
	}

	public void setIsPart(boolean isPart) {
		this.isPart = isPart ? 1 : 0;
	}

	public void setContent(byte[] content) {
		this.content = content;
	}

	public byte[] getContent() {
		return content;
	}

	static int Len = 6000;// 1000

	public List<UDPMessage> split() {
		List<UDPMessage> splited = new ArrayList<>();
//		System.out.println("[UDPMessage split] content.length" + content.length);
		if (content.length < Len) {
			splited.add(this);
			return splited;
		}
		for (int i = 0; i < content.length; i += Len) {
			UDPMessage msg = new UDPMessage();
			msg.isPart = 1;
			msg.id = this.id;
			msg.order = i / Len;
			if (i + Len > content.length) {
				msg.content = new byte[content.length - i];
				System.arraycopy(content, i, msg.content, 0, content.length - i);
			} else {
				msg.content = new byte[Len];
				System.arraycopy(content, i, msg.content, 0, Len);
			}
			splited.add(msg);
		}
		return splited;
	}

	public byte[] toByteArray() {
		try {
			ByteArrayOutputStream bo = new ByteArrayOutputStream();
			ObjectOutputStream output;
			output = new ObjectOutputStream(bo);
			output.writeObject(this);
			return bo.toByteArray();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

	public static UDPMessage parse(byte[] data, int len) {
		try {
			ByteArrayInputStream bi = new ByteArrayInputStream(data);
 			ObjectInputStream input = new ObjectInputStream(bi);
			return (UDPMessage) input.readObject();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

}
